"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;
  var tmpl = _ref.template;


  var handled = tmpl("{\n if (typeof(window.makitoo) !== \"undefined\") window.makitoo.report(\"handled\", PROBE, E);\nCATCH\n}\n");

  var unhandled = tmpl("{\n  try {\n      BODY\n  } catch(ex) {\n if (typeof(window.makitoo) !== \"undefined\")\n       window.makitoo.handleException(\"unhandled\", PROBE, ex);\n  }\n}");

  var callback = tmpl("{\nif (typeof(window.makitoo) !== \"undefined\") {\n  PROBES\n}\nBODY\n}");

  var callback_param = tmpl("if (E instanceof Error) window.makitoo.report(\"callback\", PROBE, E);");

  var hashCode = function hashCode(str) {
    var hash = 0,
        i,
        chr,
        len;
    if (str.length === 0) return hash;
    for (i = 0, len = str.length; i < len; i++) {
      chr = str.charCodeAt(i);
      hash = (hash << 5) - hash + chr;
      hash |= 0;
    }
    return hash;
  };

  var generateProbe = function generateProbe(path, state) {
    var file = state.file.opts.filename;
    file = nodepath.relative(__dirname, file);
    var probeId = file + ":" + path.node.loc.start.line + "-" + path.node.loc.start.column;
    return hashCode(probeId);
  };

  return {
    visitor: {
      CatchClause: function CatchClause(path, state) {
        try {
          if (state.opts && state.opts.handled) {
            // if we get no locations, it should be some generated code
            if (path.node.loc) {
              path.node.body = handled({
                PROBE: t.numericLiteral(generateProbe(path, state)),
                E: path.node.param,
                CATCH: path.node.body.body });
            }
          }
        } catch (err) {
          console.log("processing error", err);
        }
      },
      Function: function Function(path, state) {
        try {
          // Add error callback for parameters
          if (state.opts && state.opts.callback) {
            var params_tmpl = [];
            for (var i in path.node.params) {
              var param = path.node.params[i];
              params_tmpl.push(callback_param({
                PROBE: t.numericLiteral(generateProbe(path, state)),
                E: param
              }));
            }
            if (params_tmpl.length > 0) {
              path.node.body = callback({
                PROBES: params_tmpl,
                BODY: path.node.body.body
              });
            }
          }

          // Generate a try/catch
          if (state.opts && state.opts.unhandled) {
            path.node.body = unhandled({
              PROBE: t.numericLiteral(generateProbe(path, state)),
              BODY: path.node.body.body
            });
          }
        } catch (err) {
          console.log("processing error", err);
        }
      }
    }
  };
};

var nodepath = require("path");

module.exports = exports["default"];